local importPath = getfenv(1)._.Name;
local commonPath = string.gsub(importPath, "%.Main$", "");
import (commonPath .. ".Functions");
import (commonPath .. ".Settings");

-- WCFilter - Main --
LoadSettings(false,false);

--## fires out startup text with option settings overview ##--
-- Set vars for options on start --
local version = Plugins["WCFilter"]:GetVersion();
local col1, col2, col3, col4, col0, hello = "<rgb=#20A5DA>  ", "<rgb=#EA6020>", "<rgb=#AAA5DA>", "<rgb=#DA4040>", "</rgb>", "\n\n<u><rgb=#DAA520>WCFilter v"..version..", "..WCFLangData.by.."Burgus"..WCFLangData.loaded.." ...</rgb></u>";
local opton, optoff, FOfTxt, stmp = col3..WCFLangData.active..col0, col4..WCFLangData.inactive..col0, col4.."\n\n"..WCFLangData.WCFOfftxtA..col3..WCFLangData.WCFOfftxtB, "";
function showOptions(show)
	if (show) then hello = "\n\n<u><rgb=#DAA520>WCFilter-"..WCFLangData.mainlabel..":</rgb></u>" end;
	-- Config the texts for options-output --
	if (settings.invert == true) then textinvert = opton; else textinvert = optoff; end;
	textpltxt = select(settings.plng,WCFLangData.pdetxt,WCFLangData.pentxt,WCFLangData.pfrtxt);
	hello = hello.."\n\n <u>"..col2..WCFLangData.invert..": "..col0..textinvert.."</u>\n "..col1..WCFLangData.pltxt..": "..col0..col3..textpltxt..col0;
	local z, s, opt, state = 1, false, "", "";
	repeat
		s = select(z,settings.exfilter,settings.infilter,settings.blstate,settings.wlstate,settings.sell,settings.give,settings.valar,settings.buy,settings.search,settings.exchange,settings.group,settings.kinship,settings.craft,settings.chelp,settings.mp,settings.links,settings.higb);
		opt = select(z,WCFLangData.efstate,WCFLangData.ifstate,WCFLangData.pbllabel,WCFLangData.pwllabel,WCFLangData.sell,WCFLangData.give,WCFLangData.valar,WCFLangData.buy,WCFLangData.search,WCFLangData.exchange,WCFLangData.group,WCFLangData.kinship,WCFLangData.craft,WCFLangData.chelp,WCFLangData.mp,WCFLangData.links,WCFLangData.higb);
		if (s == true) then 
			state = opton
		else
			state = optoff
		end
		hello = hello.."\n "..col1..opt..": "..col0..state;
		z = z + 1
	until z == 17
	-- Sets say Hello to player
	localPlayer = Turbine.Gameplay.LocalPlayer.GetInstance();
	PlayerName = localPlayer:GetName();
	if not (show) then hello = hello.."\n\n "..col3.."<b><i>"..WCFLangData.hello..PlayerName.."!\n "..WCFLangData.OptTxt.."</i></b>"..col0; end;
	if fstate == false then stmp = FOfTxt; else stmp = ""; end;
	hello = hello..stmp.."\n</b>";
	-- fire out startup-text
	write(hello);
	write("");
end;
showOptions();

--## some window stuff and declare callback ##--
win = Turbine.UI.Window();
win:SetBackground("Burgus/WCFilter/lotro.tga");
win:SetVisible(true);
win:SetStretchMode(2);
win.nativeWidth, win.nativeHeight = win:GetSize();
win:SetVisible(false);
win:SetBackColorBlendMode(Turbine.UI.BlendMode.Color);
win:SetMouseVisible(false);
win:SetZOrder(2147483647);
win.backColor = color(1, 1, 1);
win.rotateAngle = 0;
win.hueAngle = 0;

AddCallback(oP, "SettingsChanged", function()
	SaveSettings(true,false);
	win:SetBackColor(win.backColor);
	win:SetVisible(false);
	win.displayStartTime = nil;
	win.x, win.y = nil, nil;
	win:SetWantsUpdates(true);
end);

--## The chatHandler for filtering the chat and output ##--
-- function for patternsearch
function CheckPattern(args, ctext, pattern)
	if string.len(pattern) >= 2 then
		local spat = "[%s%a%w%%%c%\195\128%\195\132%\195\137%\195\150%\195\156%\195\159%\195\160%\195\161%\195\162%\195\163%\195\164%\195\165%\195\166%\195\167%\195\168%\195\169%\195\170%\195\171%\195\172%\195\173%\195\174%\195\175%\195\176%\195\177%\195\178%\195\179%\195\180%\195\181%\195\182%\195\183%\195\184%\195\185%\195\186%\195\187%\195\188]+;"
		for w in string.gmatch(pattern,spat) do
			w = string.sub(w,1,string.len(w)-1)
			if string.find(ctext,w) then return true; end
		end
	end
	return false;
end;

-- function ResultCheck() needed for the function invert, to shorten the code --
function ResultCheck(args)
	if (settings.invert == true) then write(args.Message); end;
end;

-- pattern are set by eg. "string.find(CMsg, "Pattern")", the pattern have to set in lowercase only --	
function chatHandler(sender, args)
	if (fstate == true) and (args.ChatType == Turbine.ChatType.World) then
		-- init --
		local CMsg, PlayerName = string.lower(args.Message), string.lower(PlayerName);
		-- bypass own messages
		--local PlayerName = string.lower(PlayerName)
		if string.find(CMsg,PlayerName) then write(args.Message); return; --Player
		elseif string.find(CMsg,WCFLangData.own,1,56) then write(args.Message); return; --own Messages
		end
		-- examine sender from message
		local CMsg1 = string.find(CMsg,":",16)+1
		local CMsg2 = string.find(CMsg,">",CMsg1)+1
		local CMsg3 = string.find(CMsg,"<",CMsg2)-1
		local CMSender = string.lower(string.sub(CMsg,CMsg2,CMsg3))
		-- Other bypasses
		if string.find(CMsg,"WCFilter") then write(args.Message); return; --Plugin
		elseif string.find(CMSender,"^+") then write(args.Message); return; --GMs
		end
		-- Whitelist --
		if (settings.wlstate == true) then
			if settings.whitelist then
				for w in string.gmatch(settings.whitelist,"%a+") do if string.find(string.lower(w),CMSender) then write(args.Message); return; end end
			end
		end
		-- Blacklist --
		if (settings.blstate == true) then
			if settings.blacklist then
				for w in string.gmatch(settings.blacklist,"%a+") do if string.find(string.lower(w),CMSender) then return; end end
			end
		end
		-- Strip plain message
		local CMsg1 = string.find(CMsg,":",36)+3
		local CMsg2 = string.sub(CMsg, CMsg1)
		local CMsg = string.sub(CMsg2, 1, string.len(CMsg2)-2)
		-- Exclude-Filter
		if (settings.exfilter == true) then if CheckPattern(args,CMsg,settings.exfpattern) == true then return; end; end
		-- Include-Filter
		if (settings.infilter == true) then if CheckPattern(args,CMsg,settings.infpattern) == true then write(args.Message); return; end end
		-- Filterdefinition --
		if (settings.sell == true) then if CheckPattern(args,CMsg,WCFPatData[settings.plng].sell) == true then ResultCheck(args); return; end end
		if (settings.give == true) then if CheckPattern(args,CMsg,WCFPatData[settings.plng].give) == true then ResultCheck(args); return; end	end
		if (settings.valar == true) then if CheckPattern(args,CMsg,WCFPatData[settings.plng].valar) == true then ResultCheck(args); return; end end
		if (settings.buy == true) then if CheckPattern(args,CMsg,WCFPatData[settings.plng].buy) == true then ResultCheck(args); return; end end
		if (settings.search == true) then if CheckPattern(args,CMsg,WCFPatData[settings.plng].search) == true then ResultCheck(args); return; end end
		if (settings.exchange == true) then if CheckPattern(args,CMsg,WCFPatData[settings.plng].exchange) == true then ResultCheck(args); return; end end
		if (settings.group == true) then
			if string.find(CMsg, "+") then ResultCheck(args); return;
			elseif string.find(CMsg, "%d/") then ResultCheck(args); return;
			elseif CheckPattern(args,CMsg,WCFPatData[settings.plng].group) == true then ResultCheck(args); return;
			end
		end
		if (settings.kinship == true) then if CheckPattern(args,CMsg,WCFPatData[settings.plng].kinship) == true then ResultCheck(args); return; end end
		if (settings.craft == true) then if CheckPattern(args,CMsg,WCFPatData[settings.plng].craft) == true then ResultCheck(args); return; end end
		if (settings.chelp == true) then if CheckPattern(args,CMsg,WCFPatData[settings.plng].chelp) == true then ResultCheck(args); return; end end
		if (settings.mp == true) then if CheckPattern(args,CMsg,WCFPatData[settings.plng].mp) == true then ResultCheck(args); return; end end
		if (settings.links == true) then if CheckPattern(args,CMsg,WCFPatData[settings.plng].links) == true then ResultCheck(args); return; end end
		if (settings.higb == true) then if CheckPattern(args,CMsg,WCFPatData[settings.plng].higb) == true then ResultCheck(args); return; end end
		if (settings.invert == false) then write(args.Message); end;
	elseif (fstate == false) and (args.ChatType == Turbine.ChatType.World) then
		write(args.Message);
	end		
end																			

function showList(List,State,Name)
	local prefix, suffix1, suffix2 = "\n\n"..col3.."WCFilter-", "\n"..col2, "\n"..col0;
	if fstate == false then stmp = FOfTxt; else stmp = ""; end;
	if (State) then State = opton; else State = optoff; end;
	if (List == "") then
		write(prefix..Name..": "..State..suffix1..WCFLangData.empty..stmp..suffix2);
	else
		write(prefix..Name..": "..State..suffix1..List..stmp..suffix2);
	end
	write("")
end

WCFCommand = Turbine.ShellCommand();
-- handle the chat commands
function WCFCommand:Execute(name,shellCommand)
	shellCommand = string.lower(shellCommand);
	if shellCommand == WCFLangData.OptCmd then
		Turbine.PluginManager.ShowOptions(Plugins["WCFilter"]);
	elseif shellCommand == WCFLangData.SOptCmd then
		showOptions(true);
	elseif shellCommand == WCFLangData.SBlCmd then
		showList(settings.blacklist,settings.blstate,WCFLangData.pbllabel);
	elseif shellCommand == WCFLangData.SWlCmd then
		showList(settings.whitelist,settings.wlstate,WCFLangData.pwllabel);
	elseif shellCommand == WCFLangData.SIlCmd then
		showList(settings.infpattern,settings.infilter,WCFLangData.ifstate);
	elseif shellCommand == WCFLangData.SElCmd then
		showList(settings.exfpattern,settings.exfilter,WCFLangData.efstate);
	elseif shellCommand == WCFLangData.FOnCmd then
		if fstate == false then
			fstate = true;
			write(col3.."\n"..WCFLangData.WCFOn.."\n"..col0);
			write("");
		end;
	elseif shellCommand == WCFLangData.FOfCmd then
		if fstate == true then
			fstate = false;
			write(col4.."\n"..WCFLangData.WCFOff.."\n"..col0);
			write("");
		end;
	elseif shellCommand == "memory" then
		write(collectgarbage("count"));
	else 
		WCFCommand:GetHelp();
	end
end
-- The Help text that outputs when /wcf is typed;
function WCFCommand:GetHelp()
	if fstate == false then stmp = FOfTxt; else stmp = ""; end;
	write(col3.."\n<b><i>"..WCFLangData.HelpOut..stmp.."</b></i>\n"..col0);
	write("")
end
-- add the command to the shell
Turbine.Shell.AddCommand("wcf",WCFCommand);

AddCallback(Turbine.Chat,"Received",chatHandler);
