-- Default settings
defaultSettings = {
    invert = false;
	sell = true;
	give = true;
	valar = true;
	buy = true;
	search = true;
	exchange = true;
	group = false;
	kinship = false;
	craft = false;
	chelp = false;
	mp = false;
	links = false;
	higb = false;
	exfilter = false;
	infilter = false;
	exfpattern = "";
	infpattern = "";
	blstate = false;
	wlstate = false;
	blacklist = "";
	whitelist = "";
	plng = PLang;
};
DeepTableCopy(defaultSettings, settings);

--## Functions for Load and Save Data ##--
function SaveSettings(silent,server)
	local DSV = "";
	-- Workaround for Turbine localization bug
	local saveData = ExportTable(settings);
	-- ^^end
	if (server == true) then DSV = Turbine.DataScope.Server; else DSV = Turbine.DataScope.Character; end
	Turbine.PluginData.Save(DSV, "WCFilter", saveData, function() if (server == true) then sset = 1; UpdateOptionsPanel(); DoCallbacks(oP, SChng); end; end);
	DeepTableCopy(settings, settings);
	if (silent == false) then write("<rgb=#DAA5DA>WCF-Data "..WCFLangData.dstxt..".</rgb>"); end;
end

function LoadSettings(silent,server,init)
	local DSV, checks = "", 0;
	if (server == true) then DSV = Turbine.DataScope.Server; else DSV = Turbine.DataScope.Character; end
	Turbine.PluginData.Load(DSV, "WCFilter", function(loadedData)
		if (loadedData) then
			checks = 1;
			-- Workaround for Turbine localization bug
			loadedData = ImportTable(loadedData);
			DeepTableCopy(loadedData, settings)
			-- ^^end
			if (server == true) then sset = 1;  end;
			if not (init) then UpdateOptionsPanel(); DoCallbacks(oP, SChng); end;
			if (silent == false) and (not (init)) then write("<rgb=#DAA5DA>WCF-Data "..WCFLangData.dltxt..".</rgb>"); end;
		elseif (server == false) then SaveSettings(true,false);
		end
	end);
end

LoadSettings(false,true,true);

oP = Turbine.UI.Control();
--## Function for drawing the options panel ##--
function UpdateOptionsPanel()
	-- set vars
	local left, top, width, SChng, spaces, col1, col2, col0, font, fontb, fontsb, alignML, alignMC, alignLC, alignTL = 10, 10, 300, "SettingsChanged", "  ", "<b><rgb=#20A5DA>", "<b><rgb=#DAA5DA>WCF-Data: ", "</rgb></b>", Turbine.UI.Lotro.Font.Verdana12, Turbine.UI.Lotro.Font.Verdana14, Turbine.UI.Lotro.Font.TrajanPro14, Turbine.UI.ContentAlignment.MiddleLeft, Turbine.UI.ContentAlignment.MiddleCenter, Turbine.UI.ContentAlignment.LeftCenter, Turbine.UI.ContentAlignment.TopLeft;
	local UIlabel, UIcheckbox, UItextbox, UILtextbox, UILbutton, UILGbutton, UILscrollbar, UIOvert = Turbine.UI.Label, Turbine.UI.Lotro.CheckBox, Turbine.UI.TextBox, Turbine.UI.Lotro.TextBox, Turbine.UI.Lotro.Button, Turbine.UI.Lotro.GoldButton, Turbine.UI.Lotro.ScrollBar, Turbine.UI.Orientation.Vertical;
	-- function for adding lines
	local function add_h_line(top,double)
		local line, lheight = Turbine.UI.Control(), 1;
		line:SetParent(oP);
		if (double == true) then
			top = top + 28
			lheight = 3
		else
			top = top + 24
		end;
		line:SetPosition(0, top);
		line:SetSize(width + (left * 2), lheight);
		line:SetBackColor(color(41/255, 48/255, 72/255));
		return top + 8;
	end

	label = UIlabel();
	label:SetParent(oP);
	label:SetPosition(left, top);
	label:SetSize(width, 18);
	label:SetFont(fontb);
	label:SetBackColor(color(0.2, 0.2, 1));
	label:SetForeColor(color(0, 1, 0));
	label:SetText(WCFLangData.mainlabel);
	label:SetTextAlignment(alignMC);

	-- Invert --
	top = add_h_line(top,true);
	if (not oP.invert) then
		oP.invert = UIcheckbox();
		oP.invert:SetParent(oP);
		oP.invert:SetSize(width, 18);
		oP.invert:SetPosition(left, top + 1);
		oP.invert:SetFont(font);
		oP.invert:SetMarkupEnabled(true);
		oP.invert:SetBackColor(color(0.2, 0.2, 0.2));
		oP.invert:SetCheckAlignment(alignML);
		oP.invert:SetText(spaces..col1..WCFLangData.inverttxt..col0);
		oP.invert.CheckedChanged = function(box)
			settings.invert = box:IsChecked();
			DoCallbacks(oP, SChng);
		end
	end

	-- Sell --
	top = add_h_line(top,true);
	if (not oP.sell) then
		oP.sell = UIcheckbox();
		oP.sell:SetParent(oP);
		oP.sell:SetSize(width, 18);
		oP.sell:SetPosition(left, top);
		oP.sell:SetFont(font);
		oP.sell:SetCheckAlignment(alignML);
		oP.sell:SetText(spaces..WCFLangData.sell);
		oP.sell.CheckedChanged = function(box)
			settings.sell = box:IsChecked();
			DoCallbacks(oP, SChng);
		end
	end

	-- Give --
	top = add_h_line(top);
	if (not oP.give) then
		oP.give = UIcheckbox();
		oP.give:SetParent(oP);
		oP.give:SetSize(width, 16);
		oP.give:SetPosition(left, top);
		oP.give:SetFont(font);
		oP.give:SetCheckAlignment(alignML);
		oP.give:SetText(spaces..WCFLangData.give);
		oP.give.CheckedChanged = function(box)
			settings.give = box:IsChecked();
			DoCallbacks(oP, SChng);
		end
	end

	-- Valar --
	top = add_h_line(top);	
	if (not oP.valar) then
		oP.valar = UIcheckbox();
		oP.valar:SetParent(oP);
		oP.valar:SetSize(width, 16);
		oP.valar:SetPosition(left, top);
		oP.valar:SetFont(font);
		oP.valar:SetCheckAlignment(alignML);
		oP.valar:SetText(spaces..WCFLangData.valartxt);
		oP.valar.CheckedChanged = function(box)
			settings.valar = box:IsChecked();
			DoCallbacks(oP, SChng);
		end
	end

	-- Buy --
	top = add_h_line(top);	
	if (not oP.buy) then
		oP.buy = UIcheckbox();
		oP.buy:SetParent(oP);
		oP.buy:SetSize(width, 16);
		oP.buy:SetPosition(left, top);
		oP.buy:SetFont(font);
		oP.buy:SetCheckAlignment(alignML);
		oP.buy:SetText(spaces..WCFLangData.buy);
		oP.buy.CheckedChanged = function(box)
			settings.buy = box:IsChecked();
			DoCallbacks(oP, SChng);
		end
	end

	-- Search --
	top = add_h_line(top);	
	if (not oP.search) then
		oP.search = UIcheckbox();
		oP.search:SetParent(oP);
		oP.search:SetSize(width, 16);
		oP.search:SetPosition(left, top);
		oP.search:SetFont(font);
		oP.search:SetCheckAlignment(alignML);
		oP.search:SetText(spaces..WCFLangData.search);
		oP.search.CheckedChanged = function(box)
			settings.search = box:IsChecked();
			DoCallbacks(oP, SChng);
		end
	end

	-- Exchange --
	top = add_h_line(top);
	if (not oP.exchange) then	
		oP.exchange = UIcheckbox();
		oP.exchange:SetParent(oP);
		oP.exchange:SetSize(width, 16);
		oP.exchange:SetPosition(left, top);
		oP.exchange:SetFont(font);
		oP.exchange:SetCheckAlignment(alignML);
		oP.exchange:SetText(spaces..WCFLangData.exchange);
		oP.exchange.CheckedChanged = function(box)
			settings.exchange = box:IsChecked();
			DoCallbacks(oP, SChng);
		end
	end

	-- Group --
	top = add_h_line(top);
	if (not oP.group) then	
		oP.group = UIcheckbox();
		oP.group:SetParent(oP);
		oP.group:SetSize(width, 16);
		oP.group:SetPosition(left, top);
		oP.group:SetFont(font);
		oP.group:SetCheckAlignment(alignML);
		oP.group:SetText(spaces..WCFLangData.grouptxt);
		oP.group.CheckedChanged = function(box)
			settings.group = box:IsChecked();
			DoCallbacks(oP, SChng);
		end
	end

	-- Kinship --
	top = add_h_line(top);
	if (not oP.kinship) then	
		oP.kinship = UIcheckbox();
		oP.kinship:SetParent(oP);
		oP.kinship:SetSize(width, 16);
		oP.kinship:SetPosition(left, top);
		oP.kinship:SetFont(font);
		oP.kinship:SetCheckAlignment(alignML);
		oP.kinship:SetText(spaces..WCFLangData.kinship);
		oP.kinship.CheckedChanged = function(box)
			settings.kinship = box:IsChecked();
			DoCallbacks(oP, SChng);
		end
	end

	-- Craft --
	top = add_h_line(top);
	if (not oP.craft) then	
		oP.craft = UIcheckbox();
		oP.craft:SetParent(oP);
		oP.craft:SetSize(width, 16);
		oP.craft:SetPosition(left, top);
		oP.craft:SetFont(font);
		oP.craft:SetCheckAlignment(alignML);
		oP.craft:SetText(spaces..WCFLangData.craft);
		oP.craft.CheckedChanged = function(box)
			settings.craft = box:IsChecked();
			DoCallbacks(oP, SChng);
		end
	end

	-- Help --
	top = add_h_line(top);
	if (not oP.chelp) then	
		oP.chelp = UIcheckbox();
		oP.chelp:SetParent(oP);
		oP.chelp:SetSize(width, 16);
		oP.chelp:SetPosition(left, top);
		oP.chelp:SetFont(font);
		oP.chelp:SetCheckAlignment(alignML);
		oP.chelp:SetText(spaces..WCFLangData.chelp);
		oP.chelp.CheckedChanged = function(box)
			settings.chelp = box:IsChecked();
			DoCallbacks(oP, SChng);
		end
	end

	-- Monsterplay --
	top = add_h_line(top);
	if (not oP.mp) then	
		oP.mp = UIcheckbox();
		oP.mp:SetParent(oP);
		oP.mp:SetSize(width, 16);
		oP.mp:SetPosition(left, top);
		oP.mp:SetFont(font);
		oP.mp:SetCheckAlignment(alignML);
		oP.mp:SetText(spaces..WCFLangData.mptxt);
		oP.mp.CheckedChanged = function(box)
			settings.mp = box:IsChecked();
			DoCallbacks(oP, SChng);
		end
	end

	-- Links --
	top = add_h_line(top);
	if (not oP.links) then	
		oP.links = UIcheckbox();
		oP.links:SetParent(oP);
		oP.links:SetSize(width, 16);
		oP.links:SetPosition(left, top);
		oP.links:SetFont(font);
		oP.links:SetCheckAlignment(alignML);
		oP.links:SetText(spaces..WCFLangData.links);
		oP.links.CheckedChanged = function(box)
			settings.links = box:IsChecked();
			DoCallbacks(oP, SChng);
		end
	end

	-- Hi and Goodby --
	top = add_h_line(top);
	if (not oP.higb) then	
		oP.higb = UIcheckbox();
		oP.higb:SetParent(oP);
		oP.higb:SetSize(width, 16);
		oP.higb:SetPosition(left, top);
		oP.higb:SetFont(font);
		oP.higb:SetCheckAlignment(alignML);
		oP.higb:SetText(spaces..WCFLangData.higb);
		oP.higb.CheckedChanged = function(box)
			settings.higb = box:IsChecked();
			DoCallbacks(oP, SChng);
		end
	end

	-- Label Userdefined Filter
	top = add_h_line(top,true);
	label = UIlabel();
	label:SetParent(oP);
	label:SetPosition(left, top + 2);
	label:SetSize(width, 18);
	label:SetFont(font);
	label:SetBackColor(color(0.2, 0.2, 1));
	label:SetForeColor(color(0, 1, 0));
	label:SetText(WCFLangData.udflabel);
	label:SetTextAlignment(alignMC);

	-- Exclude Filter --
	top = add_h_line(top,true);
	if (not oP.exfilter) then	
		oP.exfilter = UIcheckbox();
		oP.exfilter:SetParent(oP);
		oP.exfilter:SetSize(width, 24);
		oP.exfilter:SetPosition(left, top);
		oP.exfilter:SetFont(font);
		oP.exfilter:SetCheckAlignment(alignML);
		oP.exfilter:SetTextAlignment(alignTL);
		oP.exfilter:SetText(spaces..WCFLangData.exftxt.."\n"..spaces..WCFLangData.fhinttxt);
		oP.exfilter.CheckedChanged = function(box)
			settings.exfilter = box:IsChecked();
			DoCallbacks(oP, SChng);
		end
	end
	top = add_h_line(top + 8);
	if (not oP.exfpattern) then
		oP.exfpattern = UItextbox();
		oP.exfpattern:SetSelectable();
		oP.exfpattern:SetEnabled();
		oP.exfpattern:SetParent(oP);
		oP.exfpattern:SetSize(width, 18);
		oP.exfpattern:SetPosition(left, top);
		oP.exfpattern:SetMultiline(false);
		oP.exfpattern:SetFont(fontb);
		oP.exfpattern:SetTextAlignment(alignLC);
		oP.exfpattern:SetBackColor(color(0.1, 0.1, 0.1));
		oP.exfpattern:SetText("");
		oP.exfpattern.TextChanged = function(textbox)
			settings.exfpattern = textbox:GetText();
			DoCallbacks(oP, SChng);
		end
		oP.exfpattern.FocusLost = function(textbox) SaveSettings(true,false); end
	end

	-- Include Filter --
	top = add_h_line(top,true);
	if (not oP.infilter) then	
		oP.infilter = UIcheckbox();
		oP.infilter:SetParent(oP);
		oP.infilter:SetSize(width, 24);
		oP.infilter:SetPosition(left, top);
		oP.infilter:SetFont(font);
		oP.infilter:SetCheckAlignment(alignML);
		oP.infilter:SetTextAlignment(alignTL);
		oP.infilter:SetText(spaces..WCFLangData.inftxt.."\n"..spaces..WCFLangData.fhinttxt);
		oP.infilter.CheckedChanged = function(box)
			settings.infilter = box:IsChecked();
			DoCallbacks(oP, SChng);
		end
	end
	top = add_h_line(top + 8);
	if (not oP.infpattern) then
		oP.infpattern = UItextbox();
		oP.infpattern:SetSelectable();
		oP.infpattern:SetEnabled();
		oP.infpattern:SetParent(oP);
		oP.infpattern:SetSize(width, 18);
		oP.infpattern:SetPosition(left, top);
		oP.infpattern:SetMultiline(false);
		oP.infpattern:SetFont(fontb);
		oP.infpattern:SetTextAlignment(alignLC);
		oP.infpattern:SetBackColor(color(0.1, 0.1, 0.1));
		oP.infpattern:SetText("");
		oP.infpattern.TextChanged = function(textbox)
			settings.infpattern = textbox:GetText();
			DoCallbacks(oP, SChng);
		end
		oP.infpattern.FocusLost = function(textbox) SaveSettings(true,false); end
	end

	-- Label for Player-Blacklist --
	top = add_h_line(top,true);
	label = UIlabel();
	label:SetParent(oP);
	label:SetPosition(left, top + 2);
	label:SetSize(width, 18);
	label:SetFont(fontb);
	label:SetBackColor(color(0.2, 0.2, 1));
	label:SetForeColor(color(0, 1, 0));
	label:SetText(WCFLangData.pbllabel);
	label:SetTextAlignment(alignMC);

	-- Blacklist --
	top = add_h_line(top,true);
	if (not oP.blstate) then	
		oP.blstate = UIcheckbox();
		oP.blstate:SetParent(oP);
		oP.blstate:SetSize(width, 16);
		oP.blstate:SetPosition(left, top);
		oP.blstate:SetFont(font);
		oP.blstate:SetCheckAlignment(alignML);
		oP.blstate:SetText(spaces..WCFLangData.pbltxt);
		oP.blstate.CheckedChanged = function(box)
			settings.blstate = box:IsChecked();
			DoCallbacks(oP, SChng);
		end
	end
	top = add_h_line(top);
	if (not oP.blacklist) then
		oP.blacklist = UItextbox();
		oP.blacklist:SetSelectable();
		oP.blacklist:SetEnabled();
		oP.blacklist:SetParent(oP);
		oP.blacklist:SetSize(width, 18);
		oP.blacklist:SetPosition(left, top);
		oP.blacklist:SetMultiline(false);
		oP.blacklist:SetFont(fontb);
		oP.blacklist:SetTextAlignment(alignLC);
		oP.blacklist:SetBackColor(color(0.1, 0.1, 0.1));
		oP.blacklist:SetText("");
		oP.blacklist.TextChanged = function(textbox)
			settings.blacklist = textbox:GetText();
			DoCallbacks(oP, SChng);
		end
		oP.blacklist.FocusLost = function(textbox) SaveSettings(true,false); end
	end

	-- Label for Player-Whitelist --
	top = add_h_line(top,true);
	label = UIlabel();
	label:SetParent(oP);
	label:SetPosition(left, top + 2);
	label:SetSize(width, 18);
	label:SetFont(fontb);
	label:SetBackColor(color(0.2, 0.2, 1));
	label:SetForeColor(color(0, 1, 0));
	label:SetText(WCFLangData.pwllabel);
	label:SetTextAlignment(alignMC);

	-- Whitelist --
	top = add_h_line(top,true);
	if (not oP.wlstate) then	
		oP.wlstate = UIcheckbox();
		oP.wlstate:SetParent(oP);
		oP.wlstate:SetSize(width, 16);
		oP.wlstate:SetPosition(left, top);
		oP.wlstate:SetFont(font);
		oP.wlstate:SetCheckAlignment(alignML);
		oP.wlstate:SetText(spaces..WCFLangData.pwltxt);
		oP.wlstate.CheckedChanged = function(box)
			settings.wlstate = box:IsChecked();
			DoCallbacks(oP, SChng);
		end
	end
	top = add_h_line(top);
	if (not oP.whitelist) then
		oP.whitelist = UItextbox();
		oP.whitelist:SetSelectable();
		oP.whitelist:SetEnabled();
		oP.whitelist:SetParent(oP);
		oP.whitelist:SetSize(width, 18);
		oP.whitelist:SetPosition(left, top);
		oP.whitelist:SetMultiline(false);
		oP.whitelist:SetFont(fontb);
		oP.whitelist:SetTextAlignment(alignLC);
		oP.whitelist:SetBackColor(color(0.1, 0.1, 0.1));
		oP.whitelist:SetText("");
		oP.whitelist.TextChanged = function(textbox)
			settings.whitelist = textbox:GetText();
			DoCallbacks(oP, SChng);
		end
		oP.whitelist.FocusLost = function(textbox) SaveSettings(true,false); end
	end

	-- Label for pattern language --
	top = add_h_line(top,true);
	label = UIlabel();
	label:SetParent(oP);
	label:SetPosition(left, top + 2);
	label:SetSize(width, 18);
	label:SetFont(fontb);
	label:SetBackColor(color(0.2, 0.2, 1));
	label:SetForeColor(color(0, 1, 0));
	label:SetText(WCFLangData.pllabel);
	label:SetTextAlignment(alignMC);

	-- Pattern language --
	top = add_h_line(top,true);
	if (not oP.sbar) then
		oP.sbar = UILscrollbar();
		oP.sbar:SetEnabled();
		oP.sbar:SetVisible(false);
		oP.sbar:SetParent(oP);
		oP.sbar:SetWidth(10);
		oP.sbar:SetPosition(left, top);
		oP.sbar:SetHeight(20);
		oP.sbar:SetBackColor(color(0.3, 0.3, 0.3));
		oP.sbar:SetOpacity(0.0);
		oP.sbar:SetBlendMode(0);
		oP.sbar:SetBackColorBlendMode(0);
		oP.sbar:SetValue(1);
		oP.sbar:SetMinimum(1);
		oP.sbar:SetMaximum(3);
		oP.sbar:SetOrientation(UIOvert);
		oP.sbar.ValueChanged = function(ScrollBar)
			local tmp = ScrollBar:GetValue();
			if not (settings.plng == tmp) then
				settings.plng = tmp
				local plng = select(settings.plng,WCFLangData.pdetxt,WCFLangData.pentxt,WCFLangData.pfrtxt)
				oP.plang:SetText(plng);
				write(col2..WCFLangData.pchng.." => "..plng..col0);
				DoCallbacks(oP, SChng);
			end;
		end
	end
	if (not oP.plang) then
		oP.plang = UILtextbox();
		oP.plang:SetParent(oP);
		oP.plang:SetSize(width - 12, 20);
		oP.plang:SetPosition(left + 12, top + 1);
		oP.plang:SetFont(fontsb);
		oP.plang:SetReadOnly(true)
		oP.plang:SetTextAlignment(alignMC);
		oP.plang:SetBackColor(color(0.3, 0.3, 0.3));
		oP.plang:SetForeColor(color(0.4, 1, 1));
		oP.plang:SetText("");
	end

	-- Label for reset to Defaults --
	top = add_h_line(top,true);
	label = UIlabel();
	label:SetParent(oP);
	label:SetPosition(left, top + 2);
	label:SetSize(width, 18);
	label:SetFont(fontb);
	label:SetBackColor(color(0.2, 0.2, 1));
	label:SetForeColor(color(0, 1, 0));
	label:SetText(WCFLangData.rsetlabel);
	label:SetTextAlignment(alignMC);

	-- Reset Button --
	top = add_h_line(top,true);
	local resetButton = UILGbutton();
	resetButton:SetParent(oP);
	resetButton:SetText(WCFLangData.reset);
	resetButton:SetSize(width,20);
	resetButton:SetPosition(left + 22, top + 2);
	resetButton.Click = function()
		DeepTableCopy(defaultSettings, settings);
		UpdateOptionsPanel();
		SaveSettings(true,false);
		write(col2..WCFLangData.drtxt..col0);
		DoCallbacks(oP, SChng);
	end;

	-- Label for server-wide Defaults --
	top = add_h_line(top,true);
	label = UIlabel();
	label:SetParent(oP);
	label:SetPosition(left, top + 2);
	label:SetSize(width, 18);
	label:SetFont(fontb);
	label:SetBackColor(color(0.2, 0.2, 1));
	label:SetForeColor(color(0, 1, 0));
	label:SetText(WCFLangData.swdlabel);
	label:SetTextAlignment(alignMC);

	-- Load Button --
	top = add_h_line(top,true);
	local bwidth, bleft, loadButton, saveButton = (width / 2) - 4, left + (width / 2) + 4, UILbutton(), UILbutton();
	loadButton:SetParent(oP);
	loadButton:SetText(WCFLangData.swdload);
	loadButton:SetEnabled(false);
	loadButton:SetWidth(bwidth);
	loadButton:SetPosition(left, top + 2);
	loadButton.Click = function()
		LoadSettings(true,true);
		UpdateOptionsPanel();
		write(col2..WCFLangData.spload..col0);
		DoCallbacks(oP, SChng);
	end;
	-- Save Button --
	saveButton:SetParent(oP);
	saveButton:SetText(WCFLangData.swdsave);
	saveButton:SetWidth(bwidth);
	saveButton:SetPosition(bleft, top + 2);
	saveButton.Click = function()
		SaveSettings(true,true);
		UpdateOptionsPanel();
		write(col2..WCFLangData.spsave..col0);
		DoCallbacks(oP, SChng);
	end;
	top = top + resetButton:GetHeight();
	oP:SetSize(width + 12, top + 10);

	-- Setting the states --
	if (sset == 1) then loadButton:SetEnabled(true); end;
	oP.sbar:SetValue(settings.plng);
	oP.plang:SetText(select(settings.plng,WCFLangData.pdetxt,WCFLangData.pentxt,WCFLangData.pfrtxt));
	oP.invert:SetChecked(settings.invert);
    oP.sell:SetChecked(settings.sell);
	oP.give:SetChecked(settings.give);
	oP.valar:SetChecked(settings.valar);	    
    oP.buy:SetChecked(settings.buy);
	oP.search:SetChecked(settings.search);
	oP.exchange:SetChecked(settings.exchange);
	oP.group:SetChecked(settings.group);
	oP.kinship:SetChecked(settings.kinship);
	oP.craft:SetChecked(settings.craft);
	oP.chelp:SetChecked(settings.chelp);
	oP.mp:SetChecked(settings.mp);
	oP.links:SetChecked(settings.links);
	oP.higb:SetChecked(settings.higb);
	oP.exfilter:SetChecked(settings.exfilter);
	oP.infilter:SetChecked(settings.infilter);
	oP.blstate:SetChecked(settings.blstate);
	oP.wlstate:SetChecked(settings.wlstate);
	oP.exfpattern:SetText(settings.exfpattern);
	oP.infpattern:SetText(settings.infpattern);
	oP.blacklist:SetText(settings.blacklist);
	oP.whitelist:SetText(settings.whitelist);
end

-- Display the default settings
UpdateOptionsPanel();

-- Create the "options" tab in the plugin manager.
plugin.GetOptionsPanel = function()
	return oP;
end
